#include <math.h>

double getBTEnergy (
  double *vshear,
  double *vyoung,
  double *vradh,
  double *vradw,
  double L0,
  double L1,
  double *K0,
  double twist0,
  double *nRefIni1,
  double *tRefIni1,
  double *nRefIni2,
  double *tRefIni2,
  double rtx,
  double *x1,
  double *x2,
  double *x3,
  double theta1,
  double theta2)
{
  double t10;
  double t100;
  double t101;
  double t107;
  double t108;
  double t116;
  double t12;
  double t121;
  double t123;
  double t125;
  double t130;
  double t137;
  double t14;
  double t150;
  double t153;
  double t16;
  double t165;
  double t175;
  double t176;
  double t18;
  double t186;
  double t198;
  double t199;
  double t207;
  double t209;
  double t211;
  double t213;
  double t215;
  double t217;
  double t219;
  double t220;
  double t221;
  double t227;
  double t228;
  double t234;
  double t235;
  double t243;
  double t248;
  double t25;
  double t250;
  double t252;
  double t257;
  double t264;
  double t267;
  double t27;
  double t277;
  double t280;
  double t288;
  double t292;
  double t30;
  double t303;
  double t307;
  double t31;
  double t32;
  double t325;
  double t341;
  double t346;
  double t35;
  double t358;
  double t359;
  double t36;
  double t362;
  double t363;
  double t37;
  double t371;
  double t373;
  double t375;
  double t380;
  double t387;
  double t40;
  double t400;
  double t403;
  double t41;
  double t414;
  double t425;
  double t43;
  double t432;
  double t434;
  double t44;
  double t45;
  double t48;
  double t49;
  double t52;
  double t53;
  double t56;
  double t57;
  double t59;
  double t60;
  double t61;
  double t63;
  double t64;
  double t65;
  double t67;
  double t68;
  double t69;
  double t71;
  double t73;
  double t78;
  double t79;
  double t8;
  double t80;
  double t82;
  double t84;
  double t86;
  double t88;
  double t90;
  double t92;
  double t93;
  double t94;
  t8 = vradw[0];
  t10 = vradw[1];
  t12 = 0.5e0 * t8 + 0.5e0 * t10;
  t14 = vradh[0];
  t16 = vradh[1];
  t18 = 0.5e0 * t14 + 0.5e0 * t16;
  t25 = pow(0.25e0 * t8 + 0.25e0 * t10 + 0.25e0 * t14 + 0.25e0 * t16, 0.2e1);
  t27 = x2[0];
  t30 = t27 - 0.1e1 * x1[0];
  t31 = t30 * t30;
  t32 = x2[1];
  t35 = t32 - 0.1e1 * x1[1];
  t36 = t35 * t35;
  t37 = x2[2];
  t40 = t37 - 0.1e1 * x1[2];
  t41 = t40 * t40;
  t43 = sqrt(t31 + t36 + t41);
  t44 = 0.1e1 / t43;
  t45 = t44 * t30;
  t48 = x3[0] - 0.1e1 * t27;
  t49 = t48 * t48;
  t52 = x3[1] - 0.1e1 * t32;
  t53 = t52 * t52;
  t56 = x3[2] - 0.1e1 * t37;
  t57 = t56 * t56;
  t59 = sqrt(t49 + t53 + t57);
  t60 = 0.1e1 / t59;
  t61 = t60 * t48;
  t63 = 0.1e1 * t45 * t61;
  t64 = t44 * t35;
  t65 = t60 * t52;
  t67 = 0.1e1 * t64 * t65;
  t68 = t44 * t40;
  t69 = t60 * t56;
  t71 = 0.1e1 * t68 * t69;
  t73 = 0.1e1 / (0.1e1 + t63 + t67 + t71);
  t78 = 0.1e1 * t64 * t69 - 0.1e1 * t68 * t65;
  t79 = t73 * t78;
  t80 = cos(theta1);
  t82 = tRefIni1[0] * t44;
  t84 = 0.1e1 * t82 * t30;
  t86 = tRefIni1[1] * t44;
  t88 = 0.1e1 * t86 * t35;
  t90 = tRefIni1[2] * t44;
  t92 = 0.1e1 * t90 * t40;
  t93 = t84 + t88 + t92;
  t94 = nRefIni1[2];
  t100 = 0.1e1 * t86 * t40 - 0.1e1 * t90 * t35;
  t101 = nRefIni1[1];
  t107 = 0.1e1 * t90 * t30 - 0.1e1 * t82 * t40;
  t108 = nRefIni1[0];
  t116 = 0.1e1 * t82 * t35 - 0.1e1 * t86 * t30;
  t121 = (t100 * t108 + t107 * t101 + t116 * t94) / (0.1e1 + t84 + t88 + t92);
  t123 = t93 * t94 + t100 * t101 - t107 * t108 + t121 * t116;
  t125 = sin(theta1);
  t130 = t93 * t101 + t116 * t108 - t100 * t94 + t121 * t107;
  t137 = t93 * t108 + t107 * t94 - t116 * t101 + t121 * t100;
  t150 = (0.1e1 * t45 * t137 + 0.1e1 * t64 * t130 + 0.1e1 * t68 * t123) * (0.1e1 - t80);
  t153 = t80 * t123 + t125 * (0.1e1 * t45 * t130 - 0.1e1 * t64 * t137) + 0.1e1 * t150 * t68;
  t165 = t80 * t130 + t125 * (0.1e1 * t68 * t137 - 0.1e1 * t45 * t123) + 0.1e1 * t150 * t64;
  t175 = 0.1e1 * t68 * t61 - 0.1e1 * t45 * t69;
  t176 = t73 * t175;
  t186 = t80 * t137 + t125 * (0.1e1 * t64 * t123 - 0.1e1 * t68 * t130) + 0.1e1 * t150 * t45;
  t198 = 0.1e1 * t45 * t65 - 0.1e1 * t64 * t61;
  t199 = t73 * t198;
  t207 = cos(theta2);
  t209 = tRefIni2[0] * t60;
  t211 = 0.1e1 * t209 * t48;
  t213 = tRefIni2[1] * t60;
  t215 = 0.1e1 * t213 * t52;
  t217 = tRefIni2[2] * t60;
  t219 = 0.1e1 * t217 * t56;
  t220 = t211 + t215 + t219;
  t221 = nRefIni2[2];
  t227 = 0.1e1 * t213 * t56 - 0.1e1 * t217 * t52;
  t228 = nRefIni2[1];
  t234 = 0.1e1 * t217 * t48 - 0.1e1 * t209 * t56;
  t235 = nRefIni2[0];
  t243 = 0.1e1 * t209 * t52 - 0.1e1 * t213 * t48;
  t248 = (t227 * t235 + t234 * t228 + t243 * t221) / (0.1e1 + t211 + t215 + t219);
  t250 = t220 * t221 + t227 * t228 - t234 * t235 + t248 * t243;
  t252 = sin(theta2);
  t257 = t220 * t228 + t243 * t235 - t227 * t221 + t248 * t234;
  t264 = t220 * t235 + t234 * t221 - t243 * t228 + t248 * t227;
  t267 = 0.1e1 * t61 * t257 - 0.1e1 * t65 * t264;
  t277 = (0.1e1 * t61 * t264 + 0.1e1 * t65 * t257 + 0.1e1 * t69 * t250) * (0.1e1 - t207);
  t280 = t207 * t250 + t252 * t267 + 0.1e1 * t277 * t69;
  t288 = 0.1e1 * t69 * t264 - 0.1e1 * t61 * t250;
  t292 = t207 * t257 + t252 * t288 + 0.1e1 * t277 * t65;
  t303 = 0.1e1 * t65 * t250 - 0.1e1 * t69 * t257;
  t307 = t207 * t264 + t252 * t303 + 0.1e1 * t277 * t61;
  t325 = pow(0.1000000000e1 * t79 * (0.1e1 * t64 * t153 - 0.1e1 * t68 * t165) + 0.1000000000e1 * t176 * (0.1e1 * t68 * t186 - 0.1e1 * t45 * t153) + 0.1000000000e1 * t199 * (0.1e1 * t45 * t165 - 0.1e1 * t64 * t186) + 0.1000000000e1 * t79 * (0.1e1 * t65 * t280 - 0.1e1 * t69 * t292) + 0.1000000000e1 * t176 * (0.1e1 * t69 * t307 - 0.1e1 * t61 * t280) + 0.1000000000e1 * t199 * (0.1e1 * t61 * t292 - 0.1e1 * t65 * t307) - 0.1e1 * K0[0], 0.2e1);
  t341 = pow(-0.1000000000e1 * t79 * t186 - 0.1000000000e1 * t176 * t165 - 0.1000000000e1 * t199 * t153 - 0.1000000000e1 * t79 * t307 - 0.1000000000e1 * t176 * t292 - 0.1000000000e1 * t199 * t280 - 0.1e1 * K0[1], 0.2e1);
  t346 = 0.1e1 / (0.5e0 * L0 + 0.5e0 * L1);
  t358 = t12 * t12;
  t359 = t18 * t18;
  t362 = cos(rtx);
  t363 = t63 + t67 + t71;
  t371 = (t78 * t137 + t175 * t130 + t198 * t123) * t73;
  t373 = t363 * t137 + t175 * t123 - t198 * t130 + t371 * t78;
  t375 = sin(rtx);
  t380 = t363 * t123 + t78 * t130 - t175 * t137 + t371 * t198;
  t387 = t363 * t130 + t198 * t137 - t78 * t123 + t371 * t175;
  t400 = (0.1e1 * t61 * t373 + 0.1e1 * t65 * t387 + 0.1e1 * t69 * t380) * (0.1e1 - t362);
  t403 = t362 * t373 + t375 * (0.1e1 * t65 * t380 - 0.1e1 * t69 * t387) + 0.1e1 * t400 * t61;
  t414 = t362 * t387 + t375 * (0.1e1 * t69 * t373 - 0.1e1 * t61 * t380) + 0.1e1 * t400 * t65;
  t425 = t362 * t380 + t375 * (0.1e1 * t61 * t387 - 0.1e1 * t65 * t373) + 0.1e1 * t400 * t69;
  t432 = atan2(t303 * t403 + t288 * t414 + t267 * t425, t264 * t403 + t257 * t414 + t250 * t425);
  t434 = pow(theta2 - theta1 + rtx - t432 - twist0, 0.2e1);
  return(0.1250000000e0 * (0.5e0 * vyoung[0] + 0.5e0 * vyoung[1]) * t12 * t18 * M_PI * t25 * (t325 + t341) * t346 + 0.1250000000e0 * (0.5e0 * vshear[0] + 0.5e0 * vshear[1]) * t12 * t18 * M_PI * (t358 + t359) * t434 * t346);
}
